%% switching curves for flex modes, PTOS, inside of |x1|<2c
addpath('/home/arnold/matlab/miscScripts');
clear;
clf;
clc;

T=1; %bounds for sat function
% plant parameters
% figure(2)
bo = 1.8276*10^7;
w=2*pi*3.175*10^2;
c=bo/w^2;


x1=[-2*c:.01:2*c];

%no discount yet
%alphaList=[.2 .5 .8 1];
% k1=10;

alpha=1;
xl=.4*c;
k1=(c-xl)/(c*xl);
k2=sqrt(2*c*alpha*xl-alpha*xl^2)/(alpha*w*c*xl);


T=0;
xlv=-xl:.1:xl;

x2upper_lin=-(k1/k2)*xlv-1/k2;
x2lower_lin=-(k1/k2)*xlv-1/k2;
ftl=-(k1/k2)*xlv;

fto=-w*sign(x1).*sqrt(2*alpha*c*abs(x1)-alpha*x1.^2);

ks = crossing(fto);
k = ks(2);
kxl_plus = find(x1 >=xl, 1, 'first');
kxl_min = find(x1<=-xl, 1, 'last');

fptos_plus = 1/k2 + fto(kxl_plus:end);
fptos_min  = -1/k2 + fto(1:kxl_min);



height=1.65/1.618; % width/golden ratio
width=1.1;

% For Wide Figures
% height=1.0/1.618; % width/golden ratio
F1 = figure(1);
xpos=-767; 
ypos=500;
scale=350; % 3.13 inches
figure(1); % Create Figure

axes('FontName','Times New Roman') % Set axis font style
box('on'); % Define box around whole figure
set(gcf,'Position',[xpos ypos scale*width scale*height]) % Set figure format

hold on;
p2=plot([x1(1:kxl_min)], [fptos_min], '--m', 'linewidth', 2);
p2=plot([x1(kxl_plus:end), 2*c], [fptos_plus, 1/k2], '--m', 'linewidth', 2);
p3=plot([x1, 2*c], [fto, 0], 'r', 'linewidth', 2); % f(x1), old time optimal curve
p4=plot(xlv, ftl, '--b', 'linewidth', 2); % (k1/k2)x1
p1=plot(xlv, x2upper_lin, 'k','linewidth', 2); %1/k2 + (k1/k2)x1
grid on


ax=gca;
set(ax, 'XTick', [-2*c:c:2*c]);
set(ax, 'YTick', [-bo/w:bo/w:bo/w]);
set(ax, 'YTickLabel', [])

xlim([-2*c, 2*c]);
ylim([-1.5*bo/w, 1.5*bo/w]);


yticks=get(ax, 'ytick');
xticks=get(ax, 'xtick');
set(ax, 'XTickLabel', []);

my_yticks={'$\frac{-b_o}{w}$','$0$','$\frac{b_o}{w}$'};
my_xticks={'$-2c$', '$-c$', '$0$','$c$','$2c$'};
axs=axis;
HorizontalOffset=-.2;
VertOffset=1000;

for i=1:length(yticks)
  text(axs(1)+HorizontalOffset, yticks(i),my_yticks(i),'HorizontalAlignment','Right','interpreter', 'latex', 'FontSize', 14);   

end

for i=1:length(xticks)
  text(xticks(i)+.2, axs(3)-VertOffset, my_xticks(i),'HorizontalAlignment','Right','interpreter', 'latex', 'FontSize',12);   

end
hleg1 = legend();



hleg1=legend([p1, p2, p3, p4],'$-\frac{1}{k_2}-\frac{k_1}{k_2}x_1$',...
             '$f_{to}(x_1)\pm\frac{1}{k_2}$','$f_{to}(x_1)$',...
             '$-\frac{k_1}{k_2}x_1$');
hleg1.Interpreter = 'latex';
set(hleg1,  'FontSize', 11);
% set(hleg1,'Location',)
hleg1.Position=[0.5244 0.6897 0.3800 0.2340];
set(hleg1,'box','on');

% Create xlabel
hxlab=xlabel('$x_1$','FontSize',18,'FontName','Times New Roman','FontAngle','italic');

% Create ylabel
hylab=ylabel('$x_2$','FontSize',18,'FontName','Times New Roman','FontAngle','italic','rot',0);


set(hylab, 'Units', 'Normalized', 'Position', [-.1, 0.5, 0]);
set(hxlab, 'Units', 'Normalized', 'Position', [.5, -.05, 0]);
set(hxlab, 'interpreter', 'latex');
set(hylab, 'interpreter', 'latex');

p10=plot([xl, xl], [2*bo/w, -2*bo/w], 'g', 'LineWidth', 2);
p11=plot([0, 0],  [2*bo/w, -2*bo/w], 'LineWidth', .5);
p11.Color=[.86, .86, .86];
text(.52, .03, '$x_{\ell}$', 'Units', 'Normalized', 'interpreter', 'latex', 'FontSize', 12);
text(.9, .65, '$\mathcal{U}^-$', 'Units', 'Normalized', 'interpreter', 'latex', 'FontSize', 12);
text(.9, .05, '$\mathcal{U}^+$', 'Units', 'Normalized', 'interpreter', 'latex', 'FontSize', 12);




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% plot size markes

kc_min = find(x1<=-c, 1, 'last');
ftonc = fto(kc_min);
fpnc  = fto(kc_min)-1/k2;

plot([-c, -c], [ftonc, fpnc], 'k', 'LineWidth', 1);
plot([-c-.2, -c+.2], [ftonc+300, ftonc-300], 'k', 'LineWidth', 1);
plot([-c-.2, -c+.2], [fpnc+300, fpnc-300], 'k', 'LineWidth', 1);
text(.19, .75, '$\frac{1}{k_2}$', 'Units', 'Normalized', 'interpreter', 'latex', 'FontSize', 14);





%%
% set(gcf, 'Color', 'white'); % white bckgr
% saveas(gcf, '/home/arnold/Desktop/AFM/paper-trunk/paper/plots/motivate_ptos03.eps', 'epsc')

%% 

% subplot(2,1,1)
% for i=1:length(x1)
%     if( abs(x1(i)) <= xl)
%         Fptos(i)=-(k1/k2)*x1(i);
%     else
%         Fptos(i)=-sign(x1(i))* (w*sqrt(2*alpha*c*x1(i)*sign(x1(i)) - alpha*x1(i)^2)-1/k2);
%     end
% end
% plot(x1, Fptos);
% title('-1/k2 offset, xl=.1*c')
% grid

% xl=.5*c
% k1=(c-xl)/(c*xl);
% k2=sqrt(2*c*xl - xl^2)/(w*c*xl);



% subplot(2,1,2)
% for i=1:length(x1)
%     if( abs(x1(i)) <= xl)
%         Fptos(i)=-(k1/k2)*x1(i);
%     else
%         Fptos(i)=-sign(x1(i))* (w*sqrt(2*c*x1(i)*sign(x1(i)) - x1(i)^2)-1/k2);
%     end
% wholecurve(i)=-sign(x1(i)) * (w*sqrt(2*c*x1(i)*sign(x1(i)) - x1(i)^2));    
% end
% plot(x1, Fptos, x1, wholecurve);
% title('-1/k2 offset, xl=.5*c')
% grid



