function [k2 ptosCurve] = ptosDampRef(sys, Scurve, umin, umax, wp, e1, e2, fignum, verbose)
    %%
%     x1 = linspace(-2*c, 2*c, 500);
    nn = length(Scurve(:,1));
    x1 = (linspace(Scurve(1,1), Scurve(end,1), nn))';
    
    mu    = umin;
    gamma = umax;

    xell_plus = wp*e2(1);
    xell_min  = wp*e1(1);

    % numerically differentiate. use dx = x_ell/100;
    % recall:
    % dF(x)/dx ~= [F(x) - F(x-eps)]/eps

    % eps = dx
    
    dx = min(abs(e1(1)), abs(e2(1)))/200;
    
    %%%%%%%%%%%%%%%%%%%%%%%%
    % Do This all For the Plus Side
    %%%%%%%%%%%%%%%%%%%%%%%%

    % get constant term, F(x_ell)
    Fxl_plus = interp1(Scurve(:,1), Scurve(:,2), xell_plus, 'linear');
    %F(x - eps)
    Fxl_dx_plus = interp1(Scurve(:,1), Scurve(:,2), xell_plus-dx, 'linear');
    % calc derivative
    Df_xl_plus = (Fxl_plus-Fxl_dx_plus)/dx;

    %now create some points to plot the fucker

    % the linear approxiation AT the point x_ell. NOT THROUGH the origen.
    Flin_plus = Fxl_plus + Df_xl_plus*(x1-xell_plus);
    % recall:
    % 1/k2 == x2-intercept. (k1/k2) = slope
    k2_plus = 1/(Fxl_plus - xell_plus*Df_xl_plus);
    k1_plus = Df_xl_plus*k2_plus;

    %%%%%%%%%%%%%%%%%%%%%%%%
    % Now for Minus side
    %%%%%%%%%%%%%%%%%%%%%%%
    % get constant term, F(x_ell)
    Fxl_min = interp1(Scurve(:,1), Scurve(:,2), xell_min, 'linear');
    %F(x - eps)
    Fxl_dx_min = interp1(Scurve(:,1), Scurve(:,2), xell_min-dx, 'linear');
    % calc derivative
    Df_xl_min = (Fxl_min-Fxl_dx_min)/dx;

    %now create some points to plot the fucker

    % the linear approxiation AT the point x_ell. NOT THROUif (verbose >1)
    Flin_min = Fxl_plus + Df_xl_plus*(x1-xell_min);
    % recall:
    % 1/k2 == x2-intercept. (k1/k2) = slope
    k2_min = 1/(Fxl_min - xell_min*Df_xl_plus);
    k1_min = Df_xl_min*k2_min;
    
    
    
    
    
    
    %  calculate the whole switching curve. This code differes by some signs
    %  from the code to in the case with no damping. This is for two reasons.
    %  (1), in that case, the time optimal curve, f_to(x1) required a sgn(x1)
    %  function to make the curve an odd function about the origen.
    %  (2) the function f(x1) was the NEGATIVE of the switching
    %  function. That means that in the zero damping case, k2>0, while here,
    %  k2<0.
    j = 1;
    x2_ptos = zeros(nn,1);
    
        for i=1:nn
            if( x1(i)<= -abs(xell_min) )
                F_x = interp1(Scurve(:,1), Scurve(:,2), x1(i), 'linear');
                x2_ptos(i)= F_x - abs(1/k2_min);
            elseif(x1(i) > -abs(xell_min) &  x1(i) < xell_plus )
                 x2_ptos(i)=(k1_plus/k2_plus)*x1(i);
                 x2lin(j) = x2_ptos(i);
                 x1lin(j) = x1(i);
                 j = j+1;
            elseif(x1(i) >= xell_plus)
                F_x = interp1(Scurve(:,1), Scurve(:,2), x1(i), 'linear');
                x2_ptos(i)= F_x + abs(1/k2_plus);
            end
        end
    %  get upper and lower boundaries. 
%     keyboard
    k2 = max(abs(k2_plus), abs(k2_min));
    k1 = Df_xl_min*k2;
    x2_upper = x2_ptos + abs(umin)/k2;    
    x2_lower = x2_ptos - abs(umax)/k2; 


    % produce output structure
    ptosCurve.x1        = x1;
    ptosCurve.x2_upper  = x2_upper;
    ptosCurve.x2_lower  = x2_lower;
    ptosCurve.x2_ptos   = x2_ptos;
    ptosCurve.Flin      = Flin_plus;
    ptosCurve.Fxl       = Fxl_plus;
    ptosCurve.xell_plus = xell_plus;
    ptosCurve.xell_min  = xell_min;
    ptosCurve.k1        = k1;
    

    if exist('fignum')
        figure(fignum);
        if exist('subNum', 'var')
            subplot(subNum(1), subNum(2), subNum(3))
            hold on;
            plot(ptosCurve.x1, ptosCurve.x2_ptos, ptosCurve.x1, ptosCurve.x2_upper, 'g');
            plot(ptosCurve.x1, ptosCurve.x2_lower, 'r')
            plot(x1, Flin_plus)
            % Only do for verbosity
            if (verbose >1)
            ylm = ylim;
                plot([xell_plus, xell_plus], [ylm(1), ylm(2)], '--g')
                plot([xell_min, xell_min], [ylm(1), ylm(2)], '--g')
            end
            if (verbose >2)
                plot(x1lin, x2lin, 'k')
                plot(Scurve(:,1), Scurve(:,2), '--k')
            end
            if (verbose >3)
                plot(x1, Flin_plus)
            end
        else
            hold on;

            plot(ptosCurve.x1, ptosCurve.x2_ptos, ptosCurve.x1, ptosCurve.x2_upper, 'g');
            plot(ptosCurve.x1, ptosCurve.x2_lower, 'r')
            % Only do for verbosity
            if (verbose >1)
            ylm = ylim;
                plot([xell_plus, xell_plus], [ylm(1), ylm(2)], '--g')
                plot([xell_min, xell_min], [ylm(1), ylm(2)], '--g')
            end
            if (verbose >2)
                plot(x1lin, x2lin, 'k')
                plot(Scurve(:,1), Scurve(:,2), '--k')
            end
            if (verbose >3)
                plot(x1, Flin_plus)
            end
        end
    end

    %
%     xlim([e1(1), e2(1)])












end

